/*
 * Copyright 2013 Rui Sun (SteveSunCanada@gmail.com)
 *
 * The Netty Project licenses this file to you under the Apache License,
 * version 2.0 (the "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at:
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package org.gogoup.dddutils.remote.client;

import java.net.ConnectException;

public interface RemoteConnection {

	public void close();
	
	public boolean isClosed();
	
	public Object sendRequest(Object data);
	
	/**
	 * Sends HTTP request synchronously.
	 * 
	 * @param data
	 * @param timeout
	 * @return
	 * @throws ConnectException TODO
	 * @throws RemoteConnectionException 
	 */
    public Object sendRequest(Object data, long timeout) throws RemoteConnectionException;
    
    public void sendAsynchronousRequest(Object data, RemoteConnectionListener listener);
    
    public void sendRequestAndForget(Object data) throws RemoteConnectionException;
    
    public void sendRequestAndForget(Object data, long timeout) throws RemoteConnectionException;
}
