/*
 * Copyright 2013 Rui Sun (SteveSunCanada@gmail.com)
 *
 * The Netty Project licenses this file to you under the Apache License,
 * version 2.0 (the "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at:
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package org.gogoup.dddutils.remote.server;

import org.gogoup.dddutils.appsession.AppService;
import org.gogoup.dddutils.appsession.AppSession;

public interface RemoteHttpService extends AppService{

	public void process(RemoteHttpMethod method, AppSession session, RemoteHttpResponse response);
	
	public void done(AppSession session);
	
	public void exceptionOccured(Throwable exception, AppSession session, RemoteHttpResponse response);
    
	public void connectionClosed(AppSession session);
}
